SystemOrganization addCategory: #'TP3-Objetos'!

Magnitude subclass: #Distance
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP3-Objetos'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 21:01'!
newWithAmount: anAmount unit: anUnit 

	^ self new initializeWithAmount: anAmount andUnit: anUnit.! !

!Distance class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 19:48'!
oneHundredCentimeters

	^ self newWithAmount: 100 unit: Unit centimeter.! !

!Distance class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 19:33'!
oneMeter

	^ self newWithAmount: 1 unit: (Unit meter).! !

!Distance class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:15'!
twoHundredCentimeters

	^ self newWithAmount: 200 unit: Unit centimeter.! !

!Distance class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 19:52'!
twoMeters
	
	^ self newWithAmount: 2 unit: Unit meter.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:39'!
*  aNumber
	^ Distance newWithAmount: self amount * aNumber unit: self unit .! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:23'!
+ aDistance
	"comment stating purpose of message"

	| temporary variable names |
	^ Distance newWithAmount: self amountInTheBaseUnit  + aDistance amountInTheBaseUnit  unit: Unit baseUnit  ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:25'!
- aDistance 
	"comment stating purpose of message"

	| temporary variable names |
	^  Distance newWithAmount: (self amountInTheBaseUnit - aDistance amountInTheBaseUnit ) unit: Unit baseUnit .! !

!Distance methodsFor: 'arithmetics' stamp: 'FranciscoJavierPigretti 11/7/2012 20:44'!
/ aSmallInteger 
	^ Distance newWithAmount: self amount / aSmallInteger unit: self unit .! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:48'!
< aDistance 
	^ self amountInTheBaseUnit < aDistance amountInTheBaseUnit ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'AlejandroLixKlett 11/7/2012 01:16'!
= aDistance

	^ (aDistance isKindOf: Distance) and: 	
		[(self amountInTheBaseUnit = aDistance amountInTheBaseUnit) and:
		[unit familyName = aDistance unit familyName]].! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 21:01'!
amount

	^ amount copy asFloat.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:17'!
amountInTheBaseUnit

	^ self amount * self unit scalarToTheBaseUnit. ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:51'!
convertTo: anUnit 

	^ Distance newWithAmount: (anUnit fromBaseToUnit: self amountInTheBaseUnit) unit: anUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 19:57'!
hash
	"calcula el hash de una distancia como su valor en la unidad base"

	^ self amountInTheBaseUnit ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 19:40'!
initializeWithAmount: anAmount andUnit: anUnit 

	amount := anAmount.
	unit := anUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:17'!
negated
	^ Distance newWithAmount: (self amount negated) unit: self unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 21:01'!
printOn: aStream

	|ending|
	
	ending := (amount > 1) ifTrue: 's' ifFalse: ''.
	aStream nextPutAll: amount printString, ' ', self unit printString, ending.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:17'!
unit

	^ unit copy.! !

Object subclass: #Unit
	instanceVariableNames: 'name scalarToTheBaseUnit family'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP3-Objetos'!

!Unit class methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 20:22'!
baseUnit
	^ Unit millimeter! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:14'!
centimeter
	
	^self new initializeWithName:'centimeter' aFamily: 'Distance' andScalarToTheBaseUnit: 10.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:54'!
decameter

	^ self new initializeWithName: 'decameter' aFamily: 'Distance' andScalarToTheBaseUnit: 10000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:31'!
decimeter
	
	^ self new initializeWithName: 'decimeter' aFamily: 'Distance' andScalarToTheBaseUnit: 100.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:58'!
hectometer

	^ self new initializeWithName: 'hectometer' aFamily: 'Distance' andScalarToTheBaseUnit: 100000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:33'!
kilometer

	^ self new initializeWithName: 'kilometer' aFamily: 'DIstance' andScalarToTheBaseUnit: 1000000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:14'!
meter
	
	^self new initializeWithName:'meter' aFamily: 'Distance' andScalarToTheBaseUnit: 1000.! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:31'!
millimeter

	^ self new initializeWithName: 'millimeter' aFamily: 'Distance' andScalarToTheBaseUnit: 1.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:18'!
= aUnit

	^self name = aUnit name! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:17'!
familyName
	
	^ family copy.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:52'!
fromBaseToUnit: anAmount

	^ anAmount / self scalarToTheBaseUnit.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:13'!
initializeWithName: aName aFamily: aFamily andScalarToTheBaseUnit: aScalar

	name := aName.
	scalarToTheBaseUnit := aScalar.
	family := aFamily.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:17'!
name

	^ name copy.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:29'!
printOn: aStream

	aStream nextPutAll: self name.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/5/2012 20:17'!
scalarToTheBaseUnit

	^ scalarToTheBaseUnit copy.! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP3-Objetos'!

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:30'!
centimeter
	
	^ Unit centimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:32'!
decameter
	
	^ Unit decameter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:30'!
decimeter
	
	^ Unit decimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:32'!
hectometer
	
	^ Unit hectometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:33'!
kilometer
	
	^ Unit kilometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:29'!
meter

	^ Unit meter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'Nicolas 11/5/2012 20:31'!
millimeter
	
	^ Unit millimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'FranciscoJavierPigretti 11/7/2012 20:11'!
minusOneMeter 
	
	^ Distance newWithAmount: 1 negated unit: Unit meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'FranciscoJavierPigretti 11/7/2012 20:46'!
oneCentimeter
	
	^ Distance newWithAmount: 1 unit: Unit centimeter .! !

!DistanceTest methodsFor: 'distance measures' stamp: 'Nicolas 11/5/2012 19:47'!
oneHundredCentimeters
	
	^ Distance oneHundredCentimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'Nicolas 11/5/2012 19:30'!
oneMeter
	
	^ Distance oneMeter.! !

!DistanceTest methodsFor: 'as yet unclassified' stamp: 'FranciscoJavierPigretti 11/7/2012 21:30'!
runAllTests
	"corre todos los tests"

	| selectorsStartingWithTest |
	
	selectorsStartingWithTest := (self class allSelectors select: [:aSelector | aSelector beginsWith: 'test']).
	selectorsStartingWithTest do: [:aSelector | self perform: aSelector ].! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'PLP 11/1/2012 11:54'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'PLP 11/1/2012 11:54'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'PLP 11/1/2012 11:58'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los tests de igualdad, se deben haber dado cuenta de que debemos poder
	convertir distancias a distintas unidades... y que adems dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracterstica de las distancias explcita?
	Vern que luego se torna muy til.
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters, 
	creo un array y lo recorro... Se podra escribir menos aun en este test?
	
	Y por qu se consulta sobre la cantidad y luego la unidad y no directametne sobre la distancia completa? ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10) asFloat.
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100) asFloat.
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000) asFloat.
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]
	
		"Si se pregunta por qu utiliza asFloat, esto es debido a que, en ciertas versiones de Pharo, 
		la igualdad entre fracciones y decimales tiene algunos problemas" ! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningn tipo de error por ms que se comparen objetos de distintos tipos.
	Fjense cmo se crea una instancia de Object sin ningn tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad."
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicin de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener un oneMeter en otra posicin de memoria."

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro de que ocupen distintas posiciones de memoria."
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro de que sean iguales."
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'FranciscoJavierPigretti 11/7/2012 20:40'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'PLP 11/1/2012 11:55'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'PLP 11/1/2012 11:56'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'PLP 11/1/2012 11:56'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'PLP 11/1/2012 11:56'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'PLP 11/1/2012 11:56'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'PaneroGomez 5/22/2012 20:39'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:27'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'Nicolas 11/5/2012 20:15'!
twoHundredCentimeters
	
	^ Distance twoHundredCentimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'Nicolas 11/5/2012 19:51'!
twoMeters
	
	^ Distance twoMeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'FranciscoJavierPigretti 11/7/2012 20:26'!
zeroMeters

	^ Distance newWithAmount: 0 unit: Unit baseUnit.! !
